#pragma once

#include <QtWidgets/QGraphicsView>

#include "samplereader.h"

class SoundView : public QGraphicsView {
	Q_OBJECT

public:
	explicit SoundView(QWidget* parent = nullptr);
	~SoundView();

	void loadFile(const std::string& file);

	void redraw();

	void paintEvent(QPaintEvent*) override;
	void resizeEvent(QResizeEvent*) override;
private:
	QGraphicsScene scene;

	SampleReader* samples = nullptr;

	std::string file;
	uint64_t offset = 0;
	uint64_t length = 0;
};